#include <stdio.h>
#include <stdlib.h>

int main()
{
    int N,i,Q,j,h;
    scanf("%d",&N);
    int d[N],p[N];
    scanf("%d",&Q);
    int k[Q],BrojDana[Q];
    for(i=0;i<N;i++)
    {
        scanf("%d",&d[i]);
        scanf("%d",&p[i]);
    }
    for(j=0;j<Q;j++)
    {
        scanf("%d",&k[j]);
        BrojDana[j]=0;
    }
    for(j=0;j<Q;j++)
    {
        for(i=0;i<k[j];i++)
        {
            for(h=0;h<N;h++)
            {
                if(i==d[h])
                    while(p[h]>0&&BrojDana[j]<i)
                    {
                        BrojDana[j]++;
                        p[h]--;
                    }
            }
        }
    }
    for(j=0;j<Q;j++)
        printf("%d\n",BrojDana[j]);
    return 0;
}